Index
$#! · 0-9 · A · B · C · D · E · F · G · H · I · J · K · L · M · N · O · P · Q · R · S · T · U · V · W · X · Y · Z

$#! |
| +UVM_CONFIG_DB_TRACE
| +UVM_DUMP_CMDLINE_ARGS
| +UVM_OBJECTION_TRACE
| +UVM_PHASE_TRACE
| +UVM_RESOURCE_DB_TRACE
0-9 |
| 2-2017 Class Reference UVM 1800
A |
| Audit Trail uvm_resource_base
B |
| begin_tr uvm_component
C |
| Callbacks Classes
| Command Line Debug
| compose_report_message uvm_default_report_server
| Core Service
D |
| debug_connected_to uvm_port_base
| debug_create_by_name uvm_default_factory
| debug_create_by_type uvm_default_factory
| debug_provided_to uvm_port_base
| debug_report_catcher uvm_report_catcher
| disable_auto_item_recording uvm_sequencer_base
| do_close uvm_text_tr_stream
| do_close_db uvm_text_tr_database
| do_compare uvm_tlm_generic_payload
| do_copy
| do_establish_link uvm_text_tr_database
| do_free uvm_text_tr_stream
| do_kill uvm_sequence_base
| do_open uvm_text_tr_stream
| do_open_db uvm_text_tr_database
| do_open_recorder uvm_text_tr_stream
| do_open_stream uvm_text_tr_database
| do_pack uvm_tlm_generic_payload
| do_unpack uvm_tlm_generic_payload
E |
| enable_report_id_count_summary uvm_default_report_server
| extension
F |
| Factory Component and Object Wrappers
G |
| get_all uvm_callbacks#(T,CB)
| get_comp uvm_port_base
| get_connected_to uvm_port_component#(PORT)uvm_port_component_base
| get_default uvm_line_printer uvm_table_printer uvm_tree_printer
| get_default_map uvm_reg_block
| get_default_printer uvm_default_coreservice_t
| get_enable_print_topology uvm_root
| get_first_copy uvm_copier
| get_last_copy uvm_copier
| get_next_copy uvm_copier
| get_num_copies uvm_copier
| get_packed_* uvm_packer
| get_prev_copy uvm_copier
| get_uvm_seeding uvm_coreservice_t
I |
| Implementation Agnostic API uvm_text_tr_database uvm_text_tr_stream
| Implementation Specific API uvm_text_recorder uvm_text_tr_database
| is_auto_item_recording_enabled uvm_sequencer_base
| is_tracing uvm_config_db_options uvm_resource_db_options
K |
| kind
M |
| Macros uvm_sequencer_base
| Methods Global uvm_abstract_component_registry#(T,Tname)uvm_abstract_object_registry#(T,Tname)uvm_callbacks#(T,CB)uvm_component uvm_component_registry#(T,Tname)uvm_config_db_options uvm_copier uvm_coreservice_t uvm_default_coreservice_t uvm_default_factory uvm_default_report_server uvm_line_printer uvm_object_registry#(T,Tname)uvm_packer uvm_port_base uvm_port_component#(PORT)uvm_port_component_base uvm_reg_block uvm_report_catcher uvm_resource#(T)uvm_resource_db uvm_resource_db_options uvm_root uvm_sequence_base uvm_sequencer_base uvm_table_printer uvm_tlm_generic_payload uvm_tree_printer
| Miscellaneous
N |
| new uvm_text_tr_database uvm_text_tr_stream
O |
| offset
P |
| pack_object_with_meta uvm_packer
| Packing Macros
| parent
| Port Base Classes
| print_accessors uvm_resource_base
| print_catcher uvm_report_catcher
| print_config uvm_component
| print_config_matches uvm_component
R |
| read uvm_resource#(T)
| read_by_name uvm_resource_db
| read_by_type uvm_resource_db
| record_all_messages uvm_default_report_server
| record_read_access uvm_resource_base
| record_write_access uvm_resource_base
| Recording Macros
| Report Catcher
| Resources
S |
| set_enable_print_topology uvm_root
| set_file_name uvm_text_tr_database
| set_packed_* uvm_packer
| set_type_alias uvm_abstract_component_registry#(T,Tname)uvm_abstract_object_registry#(T,Tname)uvm_component_registry#(T,Tname)uvm_object_registry#(T,Tname)
| set_uvm_seeding uvm_coreservice_t
| show_terminator uvm_default_report_server
| show_verbosity uvm_default_report_server
T |
| turn_off_tracing uvm_config_db_options uvm_resource_db_options
| turn_on_tracing uvm_config_db_options uvm_resource_db_options
U |
| ungrab uvm_sequencer_base
| unlock uvm_sequencer_base
| unpack_object_with_meta uvm_packer
| uvm_abstract_component_registry#(T,Tname)
| uvm_abstract_object_registry#(T,Tname)
| uvm_callbacks#(T,CB)
| uvm_component
| uvm_component_registry#(T,Tname)
| uvm_config_db_options
| uvm_copier
| uvm_core_state
| uvm_coreservice_t
| uvm_default_coreservice_t
| uvm_default_factory
| uvm_default_report_server
| UVM_DISABLE_AUTO_ITEM_RECORDING uvm_sequencer_base
| uvm_globals.svh
| uvm_init
| uvm_line_printer
| uvm_object_registry#(T,Tname)
| uvm_packer
| uvm_port_base
| uvm_port_component#(PORT)
| uvm_port_component_base
| uvm_port_list
| uvm_printer
| uvm_reg_block
| uvm_reg_item.svh
| uvm_report_catcher
| uvm_resource#(T)
| uvm_resource_base
| uvm_resource_db
| uvm_resource_db_options
| uvm_root
| uvm_sequence_base
| uvm_sequencer_base
| uvm_table_printer
| uvm_text_recorder
| uvm_text_tr_database
| uvm_text_tr_stream
| uvm_tlm_generic_payload
| uvm_tree_printer
| uvm_wait_for_nba_region
V |
| value
| Variables Global base/ uvm_cmdline_processor.svh reg/ uvm_reg_item.svh uvm_component uvm_default_report_server
W |
| write uvm_resource#(T)
| write_attribute uvm_text_recorder
| write_attribute_int uvm_text_recorder

+UVM_CONFIG_DB_TRACE turns on tracing of configuration DB accesses.
+UVM_DUMP_CMDLINE_ARGS allows the user to dump all command line arguments to the reporting mechanism.
+UVM_OBJECTION_TRACE turns on tracing of objection activity.
+UVM_PHASE_TRACE turns on tracing of phase executions.
+UVM_RESOURCE_DB_TRACE turns on tracing of resource DB accesses.
This library implements the API as documented in the IEEE 1800.2-2017 standard.
To find out what is happening as the simulation proceeds, an audit trail of each read and write is kept.
Implementation of uvm_component::begin_tr as described in IEEE 1800.2-2017.
This section defines the classes used for callback registration, management, and user-defined callbacks.
Debug command line plusargs that are available in the Accellera reference implementation but not documented in the IEEE UVM 1800.2-2017 LRM

> virtual function string compose_report_message(
> | uvm_report_message | report_message, |  |
> | string | report_object_name | = | ""
> )

Constructs the actual string sent to the file or command line from the report message.

> function void debug_connected_to (
> | int | level | = | 0,
> | int | max_level | = | -1
> )

The debug_connected_to method outputs a visual text display of the port/export/imp network to which this port connects (i.e., the port’s fanout).

> virtual function void debug_create_by_name (
> | string | requested_type_name, |  |
> | string | parent_inst_path | = | "",
> | string | name | = | ""
> )

Debug traces for create_*_by_name methods.

> virtual function void debug_create_by_type (
> | uvm_object_wrapper | requested_type, |  |
> | string | parent_inst_path | = | "",
> | string | name | = | ""
> )

Debug traces for create_*_by_type methods.

> function void debug_provided_to (
> | int | level | = | 0,
> | int | max_level | = | -1
> )

The debug_provided_to method outputs a visual display of the port/export network that ultimately connect to this port (i.e., the port’s fanin).

> static function void debug_report_catcher(
> | int | what | = | 0
> )

Turn on report catching debug information.

> virtual function void disable_auto_item_recording()

Disables auto_item_recording

> protected virtual function void do_close()

Callback triggered via uvm_tr_stream::close.

> protected virtual function bit do_close_db()

Close the backend connection to the database.

> function bit do_compare(
> | uvm_object | rhs,
> | uvm_comparer | comparer
> )

Compares this generic payload to rhs.

> virtual function void do_copy(
> | uvm_object | rhs
> )

Copy the rhs object into this object.

> protected virtual function void do_establish_link(
> | uvm_link_base | link
> )

Establishes a link between two elements in the database

> protected virtual function void do_free()

Callback triggered via uvm_tr_stream::free.
Implementation of the do_kill method, as described in P1800.2-2017 section 14.2.6.12.

> protected virtual function void do_open(
> | uvm_tr_database | db,
> | string | scope,
> | string | stream_type_name
> )

Callback triggered via uvm_tr_database::open_stream.

> protected virtual function bit do_open_db()

Open the backend connection to the database.

> protected virtual function uvm_recorder do_open_recorder(
> | string | name,
> | time | open_time,
> | string | type_name
> )

Marks the beginning of a new record in the stream

> protected virtual function uvm_tr_stream do_open_stream(
> | string | name,
> | string | scope,
> | string | type_name
> )

Provides a reference to a stream within the database.

> function void do_pack(
> | uvm_packer | packer
> )

Packs the fields of the payload in packer.

> function void do_unpack(
> | uvm_packer | packer
> )

Unpacks the fields of the payload from packer.

> bit enable_report_id_count_summary=1

A flag to enable report count summary for each ID

> rand uvm_object extension

Handle to optional user data, as conveyed in the call to write(), read(), mirror(), or update() used to trigger the operation.
This section defines the proxy component and object classes used by the factory.
Populates the end of the all_callbacks queue with the list of all registered callbacks for obj (whether they are enabled or disabled).

> virtual function uvm_port_component_base get_comp()

Returns a handle to the internal proxy component representing this port.

> virtual function void get_connected_to(
> | ref | uvm_port_list | list
> )

Implementation of the pure function declared in uvm_port_component_base

> pure virtual function void get_connected_to(
> | ref | uvm_port_list | list
> )

For a port or export type, this function fills list with all of the ports, exports and implementations that this port is connected to.
Implementation of uvm_line_printer::get_default as defined in section 16.2.12.2.3 of 1800.2-2017.
Implementation of uvm_table_printer::get_default as defined in section 16.2.10.2.3 of 1800.2-2017.
Implementation of uvm_tree_printer::get_default as defined in section 16.2.11.2.4 of 1800.2-2017.

> function uvm_reg_map get_default_map ()

This returns the default address map for this block.

> virtual function uvm_printer get_default_printer()

Implementation of the get_default_printer method, as defined in section F.4.1.4.13 of 1800.2-2017.

> function bit get_enable_print_topology ()

> function int unsigned get_num_copies(
> | uvm_object | rhs
> )

Returns the number of times the rhs has been copied to a unique lhs
Implementation of P1800.2 16.5.3.2

> pure virtual function bit get_uvm_seeding()

Returns the current UVM seeding enable value, as set by set_uvm_seeding.

> virtual function bit is_auto_item_recording_enabled()

Returns 1 is auto_item_recording is enabled, otherwise 0

> static function bit is_tracing()

Returns 1 if the tracing facility is on and 0 if it is off.

> static function bit is_tracing()

Returns 1 if the tracing facility is on and 0 if it is off.

> rand uvm_access_e kind

Kind of access: READ or WRITE.
The library implements the following public API at the package level beyond what is documented in IEEE 1800.2.

> function new(
> | string | name | = | "unnamed-uvm_text_tr_database"
> )

Constructor

> function new(
> | string | name | = | "unnamed-uvm_text_tr_stream"
> )

Constructor

> rand uvm_reg_addr_t offset

For memory accesses, the offset address.

> function void uvm_packer::pack_object_with_meta(
> | uvm_object | value
> )

Packs obj into the packer data stream, such that it can be unpacked via an associated unpack_object_with_meta call.
The packing macros are implemented as described in section B.2.4 of the 1800.2 specification.

> rand uvm_sequence_base parent

The sequence from which the operation originated.

> virtual function void print_accessors()

Print the read/write access history of the resource, using the accessor argument accessor which is passed to the uvm_resource#(T)::read and uvm_resource#(T)::write

> static function void print_catcher(
> | UVM_FILE | file | = | 0
> )

Prints debug information about all of the typewide report catchers that are registered.

> function void print_config(
> | bit | recurse | = | 0,
> | bit | audit | = | 0
> )

Print_config prints all configuration information for this component, as set by previous calls to uvm_config_db::set() and exports to the resources pool.

> static bit print_config_matches

Setting this static variable causes uvm_config_db::get() to print info about matching configuration settings as they are being applied.
Locates a resource by name and scope and reads its value.
Reads a value by type.

> bit record_all_messages = 0

A flag to force recording of all messages (add UVM_RM_RECORD action)

> function void record_read_access(
> | uvm_object | accessor | = | null
> )

Record the read access information for this resource for debug purposes.

> function void record_write_access(
> | uvm_object | accessor | = | null
> )

Record the write access information for this resource for debug purposes.
The recording macros are implemented as described in section B.2.3 of the 1800.2 specification.
Contains debug methods in the Accellera UVM implementation not documented in the IEEE 1800.2-2017 LRM

> function void set_enable_print_topology (
> | bit | enable
> )

> function void set_file_name(
> | string | filename
> )

Sets the file name which will be used for output.
Implementation of P1800.2 16.5.3.1

> static function bit set_type_alias(
> | string | alias_name
> )

Sets a type alias for this wrapper in the default factory.

> static function bit set_type_alias(
> | string | alias_name
> )

Sets a type alias for this wrapper in the default factory.

> static function bit set_type_alias(
> | string | alias_name
> )

Sets a type alias for this wrapper in the default factory.

> static function bit set_type_alias(
> | string | alias_name
> )

Sets a type alias for this wrapper in the default factory.

> pure virtual function void set_uvm_seeding(
> | bit | enable
> )

Sets the current UVM seeding enable value, as retrieved by get_uvm_seeding.

> bit show_terminator = 0

A flag to add a terminator in the messages, e.g.

> bit show_verbosity = 0

A flag to include verbosity in the messages, e.g.

> static function void turn_off_tracing()

Turn tracing off for the configuration database.

> static function void turn_off_tracing()

Turn tracing off for the resource database.

> static function void turn_on_tracing()

Turn tracing on for the configuration database.

> static function void turn_on_tracing()

Turn tracing on for the resource database.

> function void uvm_packer::unpack_object_with_meta(
> | inout | uvm_object | value
> )

Unpacks an object which was packed into the packer data stream using pack_object_with_meta.
Implementation of uvm_abstract_component_registry#(T,Tname), as defined by section 8.2.5.1.1 of 1800.2-2017.
Implementation of uvm_abstract_object_registry#(T,Tname), as defined by section 8.2.5.2.1 of 1800.2-2017.
Implementation of uvm_callbacks#(T,CB) class, as defined in section 10.7.2.1.
The library implements the following public API beyond what is documented in 1800.2.
Implementation of uvm_component_registry#(T,Tname), as defined by section 8.2.3.1 of 1800.2-2017.

> class uvm_config_db_options

This class contains static functions for manipulating and retrieving options that control the behavior of the configuration DB facility.
Implementation of the uvm_copier class, as defined in section 16.6.1 of 1800.2-2017
Implementation of the uvm_core_state enumeration, as defined in section F.2.10 of 1800.2-2017.
The library implements the following public API in addition to what is documented in IEEE 1800.2.
Implementation of the uvm_default_coreservice_t as defined in section F.4.2.1 of 1800.2-2017.
Default implementation of the UVM factory.
Default implementation of the UVM report server, as defined in section 6.5.2 of 1800.2-2017
Performs the same function as the 1800.2 define UVM_DISABLE_RECORDING, globally turning off automatic item recording when defined by the user.
Implementation of uvm_init, as defined in section F.3.1.3 in 1800.2-2017.
The line printer prints output in a line format.
Implementation of uvm_object_registry#(T,Tname), as defined by section 8.2.4.1 of 1800.2-2017.
Implementation of uvm_packer, as defined in section 16.5.1 of 1800.2-2017
The library implements the following public API beyond what is documented in 1800.2.

> class uvm_port_component #(
> | type | PORT | = | uvm_object
> ) extends uvm_port_component_base

This implementation of uvm_port_component class from IEEE 1800.2 declares all the API described in the LRM, plus it inherits from uvm_port_component_base for the purpose of providing the get_connected_to() method.

> virtual class uvm_port_component_base extends uvm_component

This class defines an interface for obtaining a port’s connectivity lists after or during the end_of_elaboration phase.

> typedef uvm_port_component_base uvm_port_list[string]

Associative array of uvm_port_component_base class handles, indexed by string
This is an implementation of uvm_reg_block as described in 1800.2-2017 with the addition of API described below.
Implementation of uvm_resource#(T) as defined in section C.2.5.1 of 1800.2-2017.
The library implements the following public API beyond what is documented in 1800.2.
Implementation of uvm_resource_db, as defined in section C.3.2.1 of 1800.2-2017.

> class uvm_resource_db_options

This class contains static functions for manipulating and retrieving options that control the behavior of the resources DB facility.
Implementation of uvm_sequence_base, as defined in section 14.2.1 of 1800.2-2017.
The library implements some public API beyond what is documented in 1800.2.
The table printer prints output in a tabular format.

> class uvm_text_recorder extends uvm_recorder

The uvm_text_recorder is the default recorder implementation for the uvm_text_tr_database.

> class uvm_text_tr_database extends uvm_tr_database

The uvm_text_tr_database is the default implementation for the uvm_tr_database.

> class uvm_text_tr_stream extends uvm_tr_stream

The uvm_text_tr_stream is the default stream implementation for the uvm_text_tr_database.
Implementation of uvm_tlm_generic_payload, as described in section 12.3.4.2.1 of 1800.2-2017.
By overriding various methods of the uvm_printer super class, the tree printer prints output in a tree format.

> task uvm_wait_for_nba_region

This task will block until SystemVerilog’s NBA region (or Re-NBA region if called from a program context).

> rand uvm_reg_data_t value[]

The value to write to, or after completion, the value read from the DUT.

> function void write_attribute(
> | string | nm, |  |
> | uvm_bitstream_t | value, |  |
> | uvm_radix_enum | radix, |  |
> | int | numbits | = | $bits(uvm_bitstream_t)
> )

Outputs a uvm_bitstream_t attribute to the textual log.

> function void write_attribute_int(
> | string | nm, |  |
> | uvm_integral_t | value, |  |
> | uvm_radix_enum | radix, |  |
> | int | numbits | = | $bits(uvm_bitstream_t)
> )

Outputs an uvm_integral_t attribute to the textual log